#ifndef STA_OS2_SIGNAL_HPP
#define STA_OS2_SIGNAL_HPP

#include <sta/signal.hpp>

#include <cmsis_os2.h>


namespace sta
{
	class Os2Signal : public Signal
	{
	public:
		Os2Signal(osSemaphoreId_t * semaphore);

		void notify() override;
		bool peek() override;
		bool test() override;
		void wait() override;

	private:
		osSemaphoreId_t * semaphore_;
	};
} // namespace sta


#endif // STA_OS2_SIGNAL_HPP
