#include <sta/os2/mutex.hpp>


namespace sta
{
	Os2Mutex::Os2Mutex(osMutexId_t * handle)
		: handle_{handle}
	{}

	void Os2Mutex::acquire()
	{
		osMutexAcquire(*handle_, osWaitForever);
	}

	void Os2Mutex::release()
	{
		osMutexRelease(*handle_);
	}
}
